require 'logger'
require 'net/telnet'
require 'net/smtp'

def zapisz_error(opis)
  log = File.new("/RPi/ruby/#{$data_odczytu.strftime('%Y-%m-%d')}_error.txt",'a')
  log.print("#{$data_odczytu.strftime('%Y-%m-%d %H:%M:%S')} = #{opis}\r\n")
  log.close
end

def get_sensor_data
  $data_odczytu =Time.now
  telnet = Net::Telnet::new("Host" => "192.168.0.6", "Port" => 99, "Binmode" => true, "Timeout" => 15)

  log = File.new("/RPi/ruby/RS485.txt",'a')  
  log.print("--------------------------------------------------------------------------------\r\n")


  # w tym miejscu jest odczyt innych czujnikow podpietych do magistrali RS485

  log.print("#{Time.now.strftime('%Y-%m-%d %H:%M:%S')} wysylamy znak 'b' {bufor co}\r\n")
  telnet.print('b')
  bufor = telnet.waitfor(/k/) 
  log.print("#{Time.now.strftime('%Y-%m-%d %H:%M:%S')} odpowiedz: #{bufor.strip}\r\n")
  sleep(1)
  
  if bufor.include?('ERROR') then
    log.print("#{Time.now.strftime('%Y-%m-%d %H:%M:%S')} mamy w odpowiedzi Error !\r\n")
    log.print("#{Time.now.strftime('%Y-%m-%d %H:%M:%S')} druga szansa dla bufora: ponownie wysylamy znak 'b' {bufor co}\r\n")
    telnet.print('b')
    bufor = telnet.waitfor(/k/) 
    log.print("#{Time.now.strftime('%Y-%m-%d %H:%M:%S')} odpowiedz: #{bufor.strip}\r\n")
    sleep(1)
  end

  telnet.close
  log.close
  
  buf = File.new("/RPi/ruby/bufor_#{Time.now.strftime('%Y-%m-%d')}_dane.txt",'a')
  buf.print("#{Time.now.strftime('%Y;%m;%d;%H;%M;%S')};#{bufor.strip}")
  buf.print(";\r\n")
  buf.close
rescue Exception => e
  zapisz_error(e.message)
  nil
end


get_sensor_data

